#ifndef HEADER_H
#define HEADER_H
#include <sqlite3.h>
#include <map>
#include <string>
#include <Wt/Dbo/Dbo.h>
#include <Wt/Dbo/backend/Sqlite3.h>

#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wreorder"

namespace dbo = Wt::Dbo;
using namespace std;

class caracteristiqueCS{
public:
    caracteristiqueCS():zbio(0),station_id(0),VCP(0),SES(0),SCC(0),RCS(0),PB(0),tass_sol(0),N2000(""),N2000_maj(""),Wal(""),Wal_maj(""){}
    int VCP,SES,SCC,RCS,PB,tass_sol;
    int zbio,station_id;
    std::string Wal,Wal_maj,N2000,N2000_maj;
    template<class Action>
    void persist(Action& a)
    {
        dbo::field(a, zbio,     "zbio");
        dbo::field(a, station_id, "station_id");
        dbo::field(a, VCP,     "VCP");
        dbo::field(a, SES,    "SES");
        dbo::field(a, SCC,    "SCC"); //sensibilité aux changement climatique, plus de microclimat
        dbo::field(a, RCS,    "RCS");
        dbo::field(a, PB,    "PB");
        dbo::field(a, Wal,    "Wal");
        dbo::field(a, Wal_maj,    "Wal_maj");
        dbo::field(a, N2000,    "N2000");
        dbo::field(a, N2000_maj,    "N2000_maj");
        dbo::field(a, tass_sol,    "tass_sol");
    }
    caracteristiqueCS(const caracteristiqueCS * c):zbio(c->zbio),station_id(c->station_id),VCP(c->VCP),SES(c->SES),SCC(c->SCC),RCS(c->RCS),PB(c->PB),Wal(c->Wal),Wal_maj(c->Wal_maj),N2000(c->N2000),N2000_maj(c->N2000_maj),tass_sol(c->tass_sol){}
private:
};

class cdicoAptBase : public std::enable_shared_from_this<cdicoAptBase>
{
public:
    cdicoAptBase(std::string aBDFile);
    void closeConnection();
    int openConnection();

protected:
    std::string mBDpath;
    sqlite3 **db_;
    sqlite3 * ptDb_;
    std::map<std::pair<int,int>,caracteristiqueCS> Dico_US2KK;
};

#endif // HEADER_H
