#include <iostream>
#include "header.h"

int main()
{
    cout << "Hello World!" << endl;
    cdicoAptBase *dico=new cdicoAptBase("/home/jo/app/Forestimator/carteApt/data/aptitudeEssDB.db");

    return 0;
}

cdicoAptBase::cdicoAptBase(std::string aBDFile):mBDpath(aBDFile),ptDb_(NULL)
{
    db_=&ptDb_;

    if (openConnection()){
        std::cout << " bd pas ouverte!!!\n"<< std::endl;
    } else {

        /* This first part is using slite3 without Wt */

        sqlite3_stmt * stmt;
        std::string SQLstring="SELECT Ess_FR,Code_FR,prefix, FeRe FROM dico_essences ORDER BY Ess_FR DESC;";
        sqlite3_prepare_v2( *db_, SQLstring.c_str(), -1, &stmt, NULL );//preparing the statement
        while(sqlite3_step(stmt) == SQLITE_ROW)
        {
            if (sqlite3_column_type(stmt, 0)!=SQLITE_NULL && sqlite3_column_type(stmt, 1)!=SQLITE_NULL){
                std::string aNomEs=std::string( (char *)sqlite3_column_text( stmt, 0 ) );
                std::string aCodeEs=std::string( (char *)sqlite3_column_text( stmt, 1 ) );
                std::string aPrefix=std::string( (char *)sqlite3_column_text( stmt, 2 ) );
                /* I do what i want with the result*/
            }
        }

        sqlite3_finalize(stmt);

        closeConnection();

        /* Here I use Wt:dbo */
        std::unique_ptr<dbo::backend::Sqlite3> sqlite3{new dbo::backend::Sqlite3(mBDpath)};
        Wt::Dbo::Session session;
        session.setConnection(std::move(sqlite3));
        session.mapClass<caracteristiqueCS>("caracteristiqueCS");
        dbo::Transaction transaction{session};

        // first iteration without collection (working properly)

        for (int us(1);us <18;us++){
            dbo::ptr<caracteristiqueCS>  pt = session.find<caracteristiqueCS>().where("zbio = ?").bind(1).where("station_id = ?").bind(us);
            // I create a copy of caracteristiqueCS because I am not at ease with the dbo::ptr system
            caracteristiqueCS  kkCSCopy(pt.get());
            std::cout <<"caracteristiqueCS id: " << kkCSCopy.station_id <<  std::endl;
            Dico_US2KK.emplace(std::make_pair(std::make_pair(kkCSCopy.zbio,kkCSCopy.station_id),kkCSCopy));
        }

         std::cout << "second iteration with collection"<<  std::endl;

        // test collection and iteration on element of collection
        typedef dbo::collection< dbo::ptr<caracteristiqueCS> > collectionKKCS;
        collectionKKCS col = session.find<caracteristiqueCS>().where("zbio = ?").bind(1);

        std::cout << "collection size " << col.size() << std::endl;

        dbo::collection<dbo::ptr<caracteristiqueCS>>::const_iterator i = col.begin();
        while(i != col.end())
        {
            std::cout << "caracteristiqueCS id: " << (*i)->station_id<<  std::endl;
            i++;
        }

        // third iteration without collection
         std::cout << "a last run"<< std::endl;

        for (int us(1);us <18;us++){
            dbo::ptr<caracteristiqueCS>  pt = session.find<caracteristiqueCS>().where("zbio = ?").bind(1).where("station_id = ?").bind(us);
            // I create a copy of caracteristiqueCS because I am not at ease with the dbo::ptr system
            caracteristiqueCS  kkCSCopy(pt.get());
            std::cout <<"caracteristiqueCS id: " << kkCSCopy.station_id <<  std::endl;
            Dico_US2KK.emplace(std::make_pair(std::make_pair(kkCSCopy.zbio,kkCSCopy.station_id),kkCSCopy));
        }
    }
}

void cdicoAptBase::closeConnection(){
    int rc = sqlite3_close(*db_);
    if( rc ) {
        fprintf(stderr, "Can't close database: %s\n\n\n", sqlite3_errmsg(*db_));
    }
}

int cdicoAptBase::openConnection(){
    int rc;
    rc = sqlite3_open(mBDpath.c_str(), db_);
    if( rc!=0) {
        fprintf(stderr, "Can't open database: %s\n", sqlite3_errmsg(*db_));
        std::cout << " mBDpath " << mBDpath << std::endl;
        std::cout << "result code : " << rc << std::endl;
    }
    return rc;
}
